//***********************************************************************
// Program ID    :  TEST PROGRAM FOR ANALOG/DIGITAL I/O CARDS          //
//---------------------------------------------------------------------//
// Remarks       :     The  test program was written using C language  //
//                  and compiled using Turbo C++ with a medium memory, //
//                  with an emulated floating pt and 80286 instruction //
//                  set.                                               //
//                     This test program uses  our own library and     //
//		    header file (io.h and io.lib) to test and apply    //
//		    in all Industrial I/O Adapters.  You can print     //
//		    the source code for you future reference on how    //
//                  to access the library's application. This program  //
//		    very simple just to show you the application.  No  //
//		    creative user interface to access the selection.
//---------------------------------------------------------------------//
//           How to apply and get the result using the test program    //
//                                                                     //
//	1.  Make a loop back for each adapter.  Loopback means that    //
//	    the input value should be equal to the output value.       //
//	2.  Short all the necessary pin configuration.  Please         //
//          verify the VCC and ground and D/A channels and A/D channels//
//          at user's operational manual.                              //
//	3.  Double check the loopback.				       //
//	4.  Turn off your computer.  Install an adapter card at any    //
//          available slot of the computer.			       //
//	5.  Attached the necessary loopback test to eack adapter.      //
//	6.  Turn on the computer.				       //
//	7.  Attached the positice probe of the voltmeter at one of the //
//	    channels of the loop back test, and the red probe at       //
//          ground (casing of the computer).  Try to adjust the volt-  //
//	    meter, all readings should be equal to all input channels. //
//---------------------------------------------------------------------//
//                                                                     //
// Name          :  TEST.C                                             //
// Description   :  main program ()                                    //
//               :  the main body of the program,                      //
//***********************************************************************

# include "io.h"
# include "test1.c"
# include "test2.c"
# include <stdio.h>
# include <conio.h>


int getAddress(){
	char y[5];
	unsigned count,x=0,num,total = 0;
	char c,z[2]={'0','\0'};

	gets(y);
	count = strlen(y);
	if(count>4) return -1;
       do{
       x++;
	c= y[count-x];
	z[0]=c;
	if (c >='0' && c <= '9' )
	    num = atoi(z);
	else{
	    c = toupper(c);
	     if(c>='A' && c<='F')
		num = 10 + c-'A';
	     else
	     return -1;
	}
	total += num * pow(16,x-1);
       }while( (count-x) != 0);
	return total;
}

void _176()
{ int i = 0;
  for (i=1; i<=65; i++)
   printf("%c", 176);
}


char message()
{
  gotoxy(8,3); _176();
  gotoxy(8,4); printf("%c                DECISION COMPUTER INT'L CO. LTD                %c", 176,176);
  gotoxy(8,5); _176();
  gotoxy(8,10);_176();
  gotoxy(8,11);printf("%c   This is a test program for Analog I/O and Digital I/O cards %c", 176,176);
  gotoxy(8,12);printf("%c   using our own library.  This is a simple program to show    %c",176,176);
  gotoxy(8,13);printf("%c   you how to access the library.  To get the right output,    %c",176,176);
  gotoxy(8,14);printf("%c   attached a loopback test to an adapter.                     %c ", 176,176);
  gotoxy(8,15);
  _176();
  gotoxy(22,20); printf("To continue, press any key ..........");
  return (getch());

}


void main()
{
  int option;

  clrscr();
  message();
  do{
  clrscr();
  gotoxy(25,3);printf(" M A I N    M E N U");
  gotoxy(20,5);printf(" 1. Analog I/O Device Test Program");
  gotoxy(20,6);printf(" 2. Digital I/O Devices test Program");
  gotoxy(20,7);printf(" 3. EXIT to test program");
  gotoxy(24,9);printf(" Select   [1 - 3]   :  "  );

//  do{
  switch(getche()) {

	 case '1' :clrscr();
		   test1();
		   break;

	 case '2' :clrscr();
		   test2();
		   break;

	 case '3' :
		   exit(1);
		   return;

	 default  :
		   break;
	 }

      }while(1);

}