
RESOLUTION EQU  12

LPT1    EQU     3BCH
LPT2    EQU     378H
LPT3    EQU     278H

D7      EQU     80H
D6      EQU     40H
D5      EQU     20H
D4      EQU     10H
D3      EQU     08H
D2      EQU     04H
D1      EQU     02H
D0      EQU     01H

DATA    EQU     0
STATUS  EQU     1
CONTROL EQU     2

BUSY    EQU     80H
ACK     EQU     40H
PAPEROUT EQU    20H
SELECTED EQU    10H
ERROR   EQU     08H

IRQENABLE EQU   10H
SELECT  EQU     08H
RESET   EQU     04H
LF      EQU     02H
STROBE  EQU     01H

ADDR    EQU     (D7 + D6 + D5 + D4)
CLK     EQU     D1
DATAI   EQU     D2
DATAO   EQU     SELECTED
EOC     EQU     ERROR


_DATA	segment word public 'DATA'
port_addr       dw      LPT1
port_value      db      0
dummy           db      0
prev_channel    dw      0
prev_box        dw      -1
_DATA	ends

_TEXT	segment byte public 'CODE'
	assume	cs:_TEXT
        assume  ds:_DATA
;---------------------------------------------------------------
;    udelay
;      AX : delay count
;
udelay	proc	near
        push    cx
        mov     cx,ax
udelay1:
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        loop    udelay1
        pop     cx
	ret	
udelay	endp

;---------------------------------------------------------------
;    adinit
;      AX : port addr
;
adinit  proc    near
        mov     port_addr,ax
	ret	
adinit  endp

;---------------------------------------------------------------
;    getad2(int next_ch)
;      AX : next channel
;    return : AX : AD value
;
getad2	proc	near
        push    bx
        push    cx
        push    dx
        push    si
        push    di

        mov     di,ax
        mov     cx, 5000

gad_check_eoc:
        mov     dx,port_addr
	inc	dx
	in	al,dx
	test	al,8
        jne     gad_eoc

        mov     ax, 10
        call    udelay
        loop    gad_check_eoc

        mov     ax, -1
        jmp     gad_return

gad_eoc:
	xor	si,si
        xor     ch,ch

gad_loop:
        mov     bl,port_value
        cmp     ch,3
        ja      gad_zero

	mov	ax,8
        mov     cl,ch
	sar	ax,cl
        test    ax, di
        je      gad_dummy
        or      bl, 4

gad_dummy:
        mov     dx,port_addr
        mov     al,bl
	out	dx,al

	mov	ax,1
        call    udelay

	shl	si,1

        mov     dx,port_addr
	inc	dx
	in	al,dx
	test	al,16
        je      gad_zero

	inc	si

gad_zero:
        mov     al,bl
	or	al,2
        mov     dx,port_addr
	out	dx,al

	mov	ax,1
        call    udelay

        mov     al,bl
	out	dx,al

	mov	ax,1
        call    udelay
        inc     ch
        cmp     ch,12
        jl      gad_loop

	mov	ax,si

gad_return:
        pop     di
        pop     si
        pop     dx
        pop     cx
        pop     bx
	ret	
getad2	endp

;---------------------------------------------------------------
;    getad(int box, int channel)
;      AX : box
;      CX : channel
;   return : AX : AD value
;
getad   proc    near
        push    bx
        push    cx
        push    dx
	push	si
	push	di

        mov     si,ax   ;box
        mov     di,cx   ;channel
        xor     bl,bl

        cmp     si,prev_box
        je      gad_same_box

        mov     prev_box,si
        mov     ax,si
	mov	cl,4
	shl	al,cl
        mov     port_value,al
        mov     dx,port_addr
	out	dx,al
	mov	ax,5
        call    udelay
        mov     bl,1

gad_same_box:
        cmp     di,prev_channel
        je      gad_same_channel
        mov     prev_channel,di
        mov     bl,1

gad_same_channel:
        or      bl,bl
        je      gad_the_same
        mov     ax,di
        call    getad2

gad_the_same:
        mov     ax,di
        call    getad2

	pop	di
	pop	si
        pop     dx
        pop     cx
        pop     bx
	ret	
getad   endp
_TEXT	ends
        end

