
LPT1    EQU     3BCH
LPT2    EQU     378H
LPT3    EQU     278H

D7      EQU     80H
D6      EQU     40H
D5      EQU     20H
D4      EQU     10H
D3      EQU     08H
D2      EQU     04H
D1      EQU     02H
D0      EQU     01H

DATA    EQU     0
STATUS  EQU     1
CONTROL EQU     2

BUSY    EQU     80H
ACK     EQU     40H
PAPEROUT EQU    20H
SELECTED EQU    10H
ERROR   EQU     08H

IRQENABLE EQU   10H
SELECT  EQU     08H
RESET   EQU     04H
LF      EQU     02H
STROBE  EQU     01H

ADDR    EQU     (D7 + D6 + D5 + D4)
LOAD    EQU     D3
DATAOUT EQU     D2
CLK     EQU     D1
RW      EQU     D0
DATAIN  EQU     SELECTED

_DATA	segment word public 'DATA'
port_addr       dw      LPT1
port_value      db      0
dummy           db      0
_DATA	ends

_TEXT	segment byte public 'CODE'
	assume	cs:_TEXT
        assume  ds:_DATA
;---------------------------------------------------------------
;    udelay
;      AX : delay count
;
udelay	proc	near
        push    cx
        mov     cx,ax
udelay1:
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        loop    udelay1
        pop     cx
	ret	
udelay	endp

;---------------------------------------------------------------
;    adinit
;      AX : port addr
;
ioinit  proc    near
        mov     port_addr,ax
        xor     al,al
        mov     port_value,al
	ret	
ioinit  endp

;---------------------------------------------------------------
;    getdi(int box)
;      AL : box number
;    return : AX : Digital Input value
;
getdi   proc    near
        push    bx
        push    cx
        push    dx
	push	si
	push	di

	mov	cl,4
	shl	al,cl
        mov     port_value,al

        mov     al,port_value
	out	dx,al
	mov	ax,5
        call    udelay

        mov     al,port_value
        or      al,LOAD
        out     dx,al
        mov     ax,5
        call    udelay

        mov     al,port_value
        mov     dx,port_addr
        out     dx,al
        mov     ax,5
        call    udelay

        mov     bl,0
        mov     bh,80h
        mov     cx,8
getdi0:
        mov     dx,port_addr
        inc     dx
        in      al,dx
        test    al, DATAIN
        je      getdi1
        or      bl,bh
getdi1:
        mov     dx,port_addr
        mov     al,port_value
        or      al,CLK
        out     dx,al
	mov	ax,5
        call    udelay

        mov     dx,port_addr
        mov     al,port_value
        out     dx,al
        mov     ax,5
        call    udelay

        shr     bh,1
        loop    getdi0

	pop	di
	pop	si
        pop     dx
        pop     cx
        pop     bx
	ret	
getdi   endp

;---------------------------------------------------------------
;    setdo(int box, int value)
;      AL : box number
;      BL : value
;    return : NONE
;
setdo   proc    near
        push    ax
        push    bx
        push    cx
        push    dx
	push	si
	push	di


	mov	cl,4
	shl	al,cl
        or      al, RW
        mov     port_value,al

        mov     al,port_value
	out	dx,al
	mov	ax,5
        call    udelay


        mov     bh,80h
        mov     cx,8
setdo0:
        mov     al,port_value
        test    bl,bh
        je      setdo1
        or      al,DATAOUT
        jmp     setdo2
setdo1:
        and     al,not DATAOUT
setdo2:
        mov     port_value,al

        mov     al,port_value
	out	dx,al
	mov	ax,5
        call    udelay

        mov     dx,port_addr
        mov     al,port_value
        or      al,CLK
        out     dx,al
	mov	ax,5
        call    udelay

        mov     dx,port_addr
        mov     al,port_value
        out     dx,al
	mov	ax,5
        call    udelay

        loop    setdo0

        mov     dx,port_addr
        mov     al,port_value
        or      al,LOAD
        out     dx,al
	mov	ax,5
        call    udelay

        mov     dx,port_addr
        mov     al,port_value
        out     dx,al
	mov	ax,5
        call    udelay

	pop	di
	pop	si
        pop     dx
        pop     cx
        pop     bx
        pop     ax
	ret	
setdo   endp
_TEXT	ends
        end

